using System;
using System.Collections;
using System.Runtime.InteropServices;
using System.ComponentModel;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace OlEditControlsExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("F914CCBA-F003-44E2-9AE7-EDBBF08BB7CF"), ProgId("OlEditControlsExample.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

		private AddinExpress.MSO.ADXOlInspectorCommandBar adxOlInspectorCommandBar1;
		private AddinExpress.MSO.ADXCommandBarComboBox adxCommandBarComboBox1;
		private AddinExpress.MSO.ADXCommandBarEdit adxCommandBarEdit1;
		private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxOlInspectorCommandBar1 = new AddinExpress.MSO.ADXOlInspectorCommandBar(this.components);
			this.adxCommandBarComboBox1 = new AddinExpress.MSO.ADXCommandBarComboBox(this.components);
			this.adxCommandBarEdit1 = new AddinExpress.MSO.ADXCommandBarEdit(this.components);
			this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
			// 
			// adxOlInspectorCommandBar1
			// 
			this.adxOlInspectorCommandBar1.CommandBarName = "OlEditControls Bar";
			this.adxOlInspectorCommandBar1.CommandBarTag = "8872e9a2-747f-4261-aff7-0d0026ccf5c9";
			this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarComboBox1);
			this.adxOlInspectorCommandBar1.Controls.Add(this.adxCommandBarEdit1);
			this.adxOlInspectorCommandBar1.Position = AddinExpress.MSO.ADXMsoBarPosition.adxMsoBarTop;
			this.adxOlInspectorCommandBar1.Temporary = true;
			this.adxOlInspectorCommandBar1.UpdateCounter = 6;
			// 
			// adxCommandBarComboBox1
			// 
			this.adxCommandBarComboBox1.Caption = "Items";
			this.adxCommandBarComboBox1.ControlTag = "04f341d4-d25a-478b-8350-f4ea00334344";
			this.adxCommandBarComboBox1.Items.AddRange(new string[] {
																		"Item 1",
																		"Item 2",
																		"Item 3"});
			this.adxCommandBarComboBox1.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel;
			this.adxCommandBarComboBox1.Temporary = true;
			this.adxCommandBarComboBox1.UpdateCounter = 6;
			this.adxCommandBarComboBox1.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.adxCommandBarComboBox1_Change);
			// 
			// adxCommandBarEdit1
			// 
			this.adxCommandBarEdit1.BeginGroup = true;
			this.adxCommandBarEdit1.Caption = "Text";
			this.adxCommandBarEdit1.ControlTag = "557b135d-a2eb-41d1-8c39-dea121e20254";
			this.adxCommandBarEdit1.Style = AddinExpress.MSO.ADXMsoComboStyle.adxMsoComboLabel;
			this.adxCommandBarEdit1.Temporary = true;
			this.adxCommandBarEdit1.UpdateCounter = 4;
			this.adxCommandBarEdit1.Change += new AddinExpress.MSO.ADXChange_EventHandler(this.adxCommandBarEdit1_Change);
			// 
			// adxOutlookEvents
			// 
			this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
			this.adxOutlookEvents.InspectorClose += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorClose);
			this.adxOutlookEvents.NewInspector += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_NewInspector);
			// 
			// AddinModule
			// 
			this.AddinName = "OlEditControlsExample";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private struct ControlState
		{
			public int comboboxIndex;
			public string comboboxText;
			public string editText;

			public ControlState(ControlState state)
			{
				comboboxIndex = state.comboboxIndex;
				comboboxText = state.comboboxText;
				editText = state.editText;
			}
		}

		private SortedList inspectors = new SortedList();
		private object activeInspector = null;

		private void adxCommandBarComboBox1_Change(object sender)
		{
			int hash = 0;

			try
			{
				if (activeInspector != null)
				{
					hash = activeInspector.GetHashCode();
					if (inspectors.Contains(hash))
					{
						ControlState state = new ControlState((ControlState)inspectors[hash]);
						state.comboboxIndex = adxCommandBarComboBox1.ListIndex;
						state.comboboxText = adxCommandBarComboBox1.Text;
						inspectors[hash] = state;
					}
				}
			}
			finally
			{
			}
		}

		private void adxCommandBarEdit1_Change(object sender)
		{
			int hash = 0;

			try
			{
				if (activeInspector != null)
				{
					hash = activeInspector.GetHashCode();
					if (inspectors.Contains(hash))
					{
						ControlState state = new ControlState((ControlState)inspectors[hash]);
						state.editText = adxCommandBarEdit1.Text;
						inspectors[hash] = state;
					}
				}
			}
			finally
			{
			}
		}

		private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
		{
			int hash = 0;
			
			try
			{
				activeInspector = inspector;
				hash = inspector.GetHashCode();
				if (inspectors.Contains(hash))
				{
					ControlState state = (ControlState)inspectors[hash];
					if (state.comboboxIndex > 0)
					{
						if (state.comboboxIndex != adxCommandBarComboBox1.ListIndex)
							adxCommandBarComboBox1.ListIndex = state.comboboxIndex;
					}
					else if (state.comboboxText != adxCommandBarComboBox1.Text)
					{
						adxCommandBarComboBox1.Text = state.comboboxText;
					}

					if (state.editText != adxCommandBarEdit1.Text)
					{
						adxCommandBarEdit1.Text = state.editText;
					}
				}
				else
				{
					adxCommandBarComboBox1.ListIndex = 0;
					adxCommandBarEdit1.Text = String.Empty;
					ControlState state = new ControlState();
					state.comboboxIndex = adxCommandBarComboBox1.ListIndex;
					state.comboboxText = adxCommandBarComboBox1.Text;
					state.editText = adxCommandBarEdit1.Text;
					inspectors[hash] = state;
				}
			}
			finally
			{
			}
		}

		private void adxOutlookEvents_NewInspector(object sender, object inspector, string folderName)
		{
			//
		}

		private void adxOutlookEvents_InspectorClose(object sender, object inspector, string folderName)
		{
			int hash = 0;
			
			try
			{
				hash = inspector.GetHashCode();
				if (inspectors.Contains(hash))
				{
					inspectors.Remove(hash);
				}
			}
			finally
			{
			}
		}

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

    }
}

